import Image
import textwrap

def hexify(v):
    return '0x' + hex(v)[2:].upper()

def main():
    img = Image.open('palette1.png')
    width, height = img.size
    x_size = int(width / 16.0)
    y_size = int(height / 16.0)
    print width, height
    print x_size, y_size
    colors = []
    for y in xrange(y_size / 2, height, y_size):
        old_color = None
        for x in xrange(x_size / 2, width, x_size):
            color = img.getpixel((x, y))[:3]
            colors.append(color)
    print colors
    print len(colors)

    colors += (255 - len(colors)) * ((127, 127, 127),)

    out = open('../../src/palette.h', 'wb')
    out.write('static const unsigned int STANDARD_PALETTE[] = {\n')
    values = []
    for (r, g, b) in colors:
        values.append(hexify(r | (g << 8) | (b << 16)))
    values = ', '.join(values)
    wrapper = textwrap.TextWrapper(initial_indent = '    ', 
                                   subsequent_indent = '    ')
    out.write('\n'.join(wrapper.wrap(values)))
    out.write('\n};')
    out.close()

main()